# work with CSV .spotdata files

import SpotCsv

# InputFile has keys:
# username = user-selection in drop-down or "(none)"
# numrows
# numfields
# rows = [ ['a',2,'b'],['c',3','d'],...]
# icurrent (if icurrent >= numrows, then EOF)

InputFile = {}

# -------------------------- FullFilename ----------------------------
def FullFilename(path, basename):
    if len(path) == 0:
        filename = basename
    else:
        filename = path
        if filename.find('/') >= 0 and filename[-1] != '/': filename = filename + '/'
        if filename.find('\\') >= 0 and filename[-1] != '\\': filename = filename + '\\'
        filename = filename + basename
    return filename 
    
# -------------------------- ParseCSV --------------------------------
def ParseCSV(path, basename):
    global InputFile
    InputFile = {}
    rows = []

    username = basename
    if username.find('.') >= 0: username = username[:username.find('.')]

    filename = FullFilename(path, basename)
    
    InputFile['username'] = username
    InputFile['icurrent'] = 0
    
    if username == '(none)':
        InputFile['numrows'] = 0
        InputFile['numfields'] = 0
    else:
        SpotCsv.readfile(filename)
        for row in SpotCsv.rows():
            if len(row) > 0:
                InputFile['numfields'] = len(row)
                # convert any integer-like strings to integers
                for i in range(len(row)):
                    val = row[i]
                    if isInteger(val):
                        row[i] = int(val)
                rows.append(row)
        InputFile['rows'] = rows
        InputFile['numrows'] = len(rows)
    return InputFile

def isInteger(s):
    s2 = str(s)
    if len(s2)==0:
        return False
    if s2.isdigit() or (s2[0]=='-' and s2[1:].isdigit()):
        return True
    return False




