# Instruction line class

# required attributes:
# sline = raw line
# type = 'blank', 'comment', 'label', 'command'

# optional attributes:
# command = lower-case of command
# label = label-name
# args (dictionary with keys: arg0_type, arg0_value, etc.)

class insline:
    pass


argtypes = ['card','string','number','label','special']

arg_c = ['card']
arg_n = ['number']
arg_l = ['label']
arg_s = ['string']
arg_S = ['special']
arg_nc = ['number','card']
arg_sc = ['string','card']
arg_cc = ['card','card']
arg_lcs = ['label','card','string']
arg_lcn = ['label','card','number']
arg_lcc = ['label','card','card']
arg_ccc = ['card','card','card']
arg_cnc = ['card','number','card']
arg_ncc = ['number','card','card']

commands = {'next' : [[]],
            'read-prop' : [arg_nc],
            'rewind' : [[]],
            'say' : [arg_c, arg_n, arg_s, arg_S],
            'saybin': [arg_c, arg_n],
            'sayhex': [arg_c, arg_n],
            'write' : [arg_nc, arg_sc, arg_cc],
            'write-from-ind' : [arg_ccc, arg_ncc],
            'write-to-ind' : [arg_ccc, arg_cnc],
            'push' : [arg_c],
            'pop' : [arg_c],
            'stop' : [[]],
            'jump' : [arg_l],
            'jump-if-eof' : [arg_l],
            'jump-if-eq' : [arg_lcn, arg_lcs, arg_lcc],
            'jump-if-ne' : [arg_lcn, arg_lcs, arg_lcc],
            'jump-if-gt' : [arg_lcn, arg_lcs, arg_lcc],
            'jump-if-ge' : [arg_lcn, arg_lcs, arg_lcc],
            'jump-if-le' : [arg_lcn, arg_lcs, arg_lcc],
            'jump-if-lt' : [arg_lcn, arg_lcs, arg_lcc],
            'gosub' : [arg_l],
            'return' : [[]],
            'inc' : [arg_c],
            'dec' : [arg_c],
            'add' : [arg_ccc, arg_cnc, arg_ncc],
            'sub' : [arg_ccc, arg_cnc, arg_ncc],
            'mul' : [arg_ccc, arg_cnc, arg_ncc],
            'div' : [arg_ccc, arg_cnc, arg_ncc],
            'mod' : [arg_ccc, arg_cnc, arg_ncc],
            'and' : [arg_ccc, arg_cnc, arg_ncc],
            'or'  : [arg_ccc, arg_cnc, arg_ncc],
            'xor' : [arg_ccc, arg_cnc, arg_ncc],
            'comp': [arg_cc],
            'rshift' : [arg_cnc],
            'lshift' : [arg_cnc],
            }
commandnames = commands.keys()

def isspecial(s): return (s[0]=='_')
def isnumber(s):
    return s.isdigit() or (len(s)>1 and (s[0]=='-' and s[1:].isdigit()))
def islabel(s): return not isnumber(s)
def iscard(s):
    if len(s)<2: return False
    if s[0] == 'c' and s[1:].isdigit():
        if int(s[1:]) >= 0:
            return True
    return False



