#! /usr/bin/python

# -----------------------------------
#   Utilities for Spot
# -----------------------------------

import string
import os

HomeDir = ''

# ----------------- FileToList ------------------
# Return a list of trimmed lines from text file
def FileToList(filename):
    f = open(filename, 'r')
    llines = f.readlines()
    f.close()
    if len(llines) > 0:
        for i in range(len(llines)):
            llines[i] = llines[i].strip
    return llines

# -------------------- GetFile -----------------
# Returns the file, or ''
def GetFile(filename):
    try:
        f = open(filename, 'r')
        s = f.read()
        f.close()
        return s
    except IOError:
        return ''
    
# ----------------- GetHomeDir -------------------
def GetHomeDir():
    global HomeDir
    HomeDir = os.getcwd()
    return HomeDir

# -------------------ListFilesHavingSuffix ----------
# Usage: ListFilesHavingSuffix(os.getcwd(), '.py', True)
def ListFilesWithSuffix(path, suffix, WithSuffix=False):
    l = []
    lsuffix = suffix.lower()
    for f in os.listdir(path):
        if f.lower().endswith(lsuffix):
            if not WithSuffix:
                f = f[:-len(suffix)]
            l.append(f)
    return l

# ---------------------- GetEnv ------------------
# Usage: GetEnv('path') (case-independent search)
def GetEnv(key,default=''):
    lkey = key.lower()
    keys = os.environ.keys()
    if key in keys:
        return os.environ[key]
    for trial_key in keys:
        if lkey == trial_key.lower():
            return os.environ[trial_key]
    return default

# --------------------- WriteFile -----------------
# Usage: WriteFile(filename, string)
def WriteFile(filename, outstring):
    try:
        f = open(filename,'w')
        f.write(outstring)
        f.close()
    except:
        a=1/0
    
