# SpotWordsize

# Utilities for limiting the wordsize

WordsizeLimits={}

def toBin(n,wordsize):
    res=[]
    if wordsize>0:
        for i in range(wordsize):
            res.append('01'[n & 1])
            n /= 2
        res2=addspaces(res, 4)
        res2.reverse()
        return "".join(res2)
    elif wordsize==0:
        return toBin(n, _log2(abs(n)))

def _log2(n):
    if n==0: return 1
    lg = 0
    while n != 0:
        n /= 2
        lg += 1
    return lg

def toHex(n,wordsize):
    """wordsize must be a multiple of 4"""
    res=[]
    if wordsize > 0:
        for i in range(wordsize/4):
            res.append('0123456789abcdef'[n & 15])
            n /= 16
        res2=addspaces(res, 4)
        res2.reverse()
        return "".join(res2)
    elif wordsize==0:
        lg = _log2(abs(n))
        lg2 = 4*(((lg-1)/4)+1) # round up to multiple of 4
        return toHex(n,lg2)
        
def addspaces(lst, everyn):
    nspaces = (len(lst)-1)/4
    if nspaces == 0: return lst
    lst2 = lst[:]
    for i in range(nspaces):
        n = (i+1)*(everyn+1)-1
        lst2 = lst2[:n]+[' ']+lst2[n:]
    return lst2

    
def WordsizeLimitsInit():
    global WordsizeLimits
    for i in (4,8,16,32,64):
        WordsizeLimits[i] = (2**(i-1))-1
        WordsizeLimits[-i]=-(2**(i-1))
        
def limitToWordsize(n,wordsize):
    if wordsize==0: return n
    if len(WordsizeLimits)==0: WordsizeLimitsInit()
    if WordsizeLimits[-wordsize] <= n <= WordsizeLimits[wordsize]:
        return n
    # convert to binary string and chop at wordsize
    s=toBin(n,wordsize)
    return binToN(s.replace(' ',''))

def binToN(s):
    tot=0
    if s[0]=='0':
        for c in s:
            tot *= 2
            if c=='1': tot+=1
    else:
        for c in s:
            tot *= 2
            if c=='0': tot+=1
        tot = -(tot+1)
    return tot

    
